/*
 * space v1.0.0 (C) 1997 Mikael Klasson aka Fluff of Logic Design
 * read COPYING now for more important info.
 *
 * enjoy...
 */


#include <stdio.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>


#define VERSION "1.0.0"
#define MAX_NAMELENGTH	260


void processdir( char * );
void processfile( char * );


int		lowercase = 0, uppercase = 0;
int		subdirs = 0, renamedirs = 0;


void main( int argc, char **argv )
{
	int		i, i2;
	int		help = 0;
	int		dashdash = 0;

	if( argc < 2 ) {
		printf( "space: usage: space [OPTIONS] [--] FILENAMES\n" );
		printf( "for help, try: space --help\n" );
		return;
	} 

	for( i = 1; i < argc; i++ ) {
		if( argv[i][0] != '-' ) continue;
		if( !strncmp( argv[i], "--", 2 ) ) {
			if( strlen( argv[i] ) == 2 ) break;
			if( !strcmp( argv[i], "--directories" ) ) renamedirs = 1;
			if( !strcmp( argv[i], "--help" ) ) help = 1;
			if( !strcmp( argv[i], "--lower" ) ) lowercase = 1;
			if( !strcmp( argv[i], "--upper" ) ) uppercase = 1;
			if( !strcmp( argv[i], "--recursive" ) ) subdirs = 1;
		} else {
			for( i2 = 1; i2 < strlen( argv[i] ); i2++ ) {
				if( argv[i][i2] == 'd' ) renamedirs = 1;
				if( argv[i][i2] == 'h' ) help = 1;
				if( argv[i][i2] == 'l' ) lowercase = 1;
				if( argv[i][i2] == 'u' ) uppercase = 1;
				if( argv[i][i2] == 'R' ) subdirs = 1;
			}
		}
	}
	
	if( help ) {
		printf( "\nspace v%s (C) 1997 Mikael Klasson aka Fluff of Logic Design\n", VERSION );
		printf( "usage: space [OPTIONS] [--] FILENAMES\n\n" );
		printf( "  -d, --directories	rename directories as well\n" );
		printf( "  -h, --help		print this help message\n" );
		printf( "  -l, --lower		convert to lowercase\n" );
		printf( "  -p, --parentheses	convert parentheses into dashes\n" );
		printf( "  -u, --upper		convert to uppercase\n" );
		printf( "  -R, --recursive	recurse into subdirs\n\n" );
		printf( "this program converts spaces in filenames into underscores.\n" );
		printf( "Everything after -- is interpreted as filenames\n\n");
		return;
	}

	if( lowercase && uppercase ) {
		printf( "space: you actually think converting to both upper and lower case makes sense?\n" );
		return;
	}

	for( i = 1; argv[i]; i++ ) {
		if( argv[i][0] != '-' || dashdash ) {
			processfile( argv[i] );
		} else if( !strcmp( argv[i], "--" ) )
			dashdash = 1;
	}
}


void processfile( char *filename )
{
	struct stat	statbuf;
	int		i;
	char		newname[MAX_NAMELENGTH + 1];

	lstat( filename, &statbuf );

	strncpy( newname, filename, MAX_NAMELENGTH );
	newname[MAX_NAMELENGTH] = '\0';

	if( S_ISREG( statbuf.st_mode ) || S_ISLNK( statbuf.st_mode ) || ( S_ISDIR( statbuf.st_mode ) && renamedirs ) ) {
		for( i = 0; i < strlen( newname ); i++ ) {
			if( lowercase && isupper( newname[i] ) )
				newname[i] = tolower( newname[i] );
			else if( uppercase && islower( newname[i] ) )
				newname[i] = toupper( newname[i] );
			else if( newname[i] == ' ' )
				newname[i] = '_';
		}
		if( strcmp( filename, newname ) ) {
			rename( filename, newname );
			printf( "space: `%s' -> `%s'\n", filename, newname );
		}
	}
	if( S_ISDIR( statbuf.st_mode ) && !S_ISLNK( statbuf.st_mode ) && subdirs \
		&& strcmp( filename, "." ) && strcmp( filename, ".." ) )
			processdir( newname );
}


void processdir( char *dirname )
{
	struct dirent	*dir_ent;
	struct DIR	*dir;

	if( chdir( dirname ) ) 
		return;

	if( ( dir = opendir( "." ) ) ) {
		while( ( dir_ent = readdir( dir ) ) )
			processfile( dir_ent->d_name );
		closedir( dir );
	}

	chdir( ".." );
}
